ALTER TABLE PRODUTO ADD VRENRGNUTRI VARCHAR2(10)
/

ALTER TABLE PRODUTO ADD QTDCARBNUTRI VARCHAR2(10)
/

ALTER TABLE PRODUTO ADD QTDPROTNUTRI VARCHAR2(10)
/

ALTER TABLE PRODUTO ADD QTDGTOTNUTRI VARCHAR2(10)
/

ALTER TABLE PRODUTO ADD QTDGSATNUTRI VARCHAR2(10)
/

ALTER TABLE PRODUTO ADD QTDGTRANUTRI VARCHAR2(10)
/

ALTER TABLE PRODUTO ADD QTDFIBRANUTRI VARCHAR2(10)
/

ALTER TABLE PRODUTO ADD QTDSODNUTRI VARCHAR2(10)
/

ALTER TABLE PRODUTO ADD DSVITNUTRI VARCHAR2(50)
/

ALTER TABLE PARAVEND ADD DSUNIDADE VARCHAR2(200)
/

ALTER TABLE PARAVEND ADD LINKLOCALURL VARCHAR2(2000)
/

CREATE TABLE CHEFE(
    CDCHEFE           VARCHAR2(4)     NOT NULL, 
    NMCHEFE           VARCHAR2(50)    NOT NULL,
    NRORG             NUMBER 	      DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') 		NOT NULL,
    IDATIVO           VARCHAR2(1)     DEFAULT 'S'					NOT NULL,
    DTINCLUSAO        DATE            DEFAULT SYSDATE,
    DTULTATU          DATE            DEFAULT SYSDATE,
    NRORGINCLUSAO     NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERINCLUSAO    VARCHAR2(12)    DEFAULT '1' 					NULL,
    NRORGULTATU       NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERULTATU      VARCHAR2(12)    DEFAULT '1',
	    CONSTRAINT CKC_IDATIVO_CHEFE CHECK (IDATIVO IN ('S','N')),
        CONSTRAINT PK_CHEFE PRIMARY KEY (CDCHEFE)
)
/

CREATE TABLE CHEFEFILIAL(
    CDCHEFE           VARCHAR2(10)    NOT NULL,
    CDFILIAL          VARCHAR2(4)     NOT NULL,
    NRORG             NUMBER 	      DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') 		NOT NULL,
    IDATIVO           VARCHAR2(1)     DEFAULT 'S'					NOT NULL,
    DTINCLUSAO        DATE            DEFAULT SYSDATE,
    DTULTATU          DATE            DEFAULT SYSDATE,
    NRORGINCLUSAO     NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERINCLUSAO    VARCHAR2(12)    DEFAULT '1' 					NULL,
    NRORGULTATU       NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERULTATU      VARCHAR2(12)    DEFAULT '1',
	    CONSTRAINT CKC_IDATIVO_CHEFEFILIAL CHECK (IDATIVO IN ('S','N')),
        CONSTRAINT PK_CHEFEFILIAL PRIMARY KEY (CDFILIAL, CDCHEFE)
)
/

ALTER TABLE CHEFEFILIAL ADD CONSTRAINT FKVND00858CHEFEFILIAL FOREIGN KEY(CDCHEFE) REFERENCES CHEFE(CDCHEFE) 
/

CREATE INDEX VND00858_FK ON CHEFEFILIAL (CDCHEFE ASC)
/

ALTER TABLE CHEFEFILIAL ADD CONSTRAINT FKVND00859CHEFECDFILIAL FOREIGN KEY(CDFILIAL) REFERENCES FILIAL(CDFILIAL) 
/

CREATE INDEX VND00859_FK ON CHEFEFILIAL (CDFILIAL ASC)
/

CREATE TABLE TAG(
    CDTAG             VARCHAR2(4)     NOT NULL,
    NMTAG             VARCHAR2(30)    NOT NULL,
    NRORG             NUMBER 	      DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') 		NOT NULL,
    IDATIVO           VARCHAR2(1)     DEFAULT 'S'					NOT NULL,
    DTINCLUSAO        DATE            DEFAULT SYSDATE,
    DTULTATU          DATE            DEFAULT SYSDATE,
    NRORGINCLUSAO     NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERINCLUSAO    VARCHAR2(12)    DEFAULT '1' 					NULL,
    NRORGULTATU       NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERULTATU      VARCHAR2(12)    DEFAULT '1',
	    CONSTRAINT CKC_IDATIVO_TAG CHECK (IDATIVO IN ('S','N')),
        CONSTRAINT PK_TAG PRIMARY KEY (CDTAG)
)
/

CREATE TABLE UNIDADETAG(
    CDTAG             VARCHAR2(4)     NOT NULL,
    CDFILIAL          VARCHAR2(4)     NOT NULL,
    NRORG             NUMBER 	      DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') 		NOT NULL,
    IDATIVO           VARCHAR2(1)     DEFAULT 'S'					NOT NULL,
    DTINCLUSAO        DATE            DEFAULT SYSDATE,
    DTULTATU          DATE            DEFAULT SYSDATE,
    NRORGINCLUSAO     NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERINCLUSAO    VARCHAR2(12)    DEFAULT '1' 					NULL,
    NRORGULTATU       NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERULTATU      VARCHAR2(12)    DEFAULT '1',
	    CONSTRAINT CKC_IDATIVO_UNIDADETAG CHECK (IDATIVO IN ('S','N')),
        CONSTRAINT PK_UNIDADETAG PRIMARY KEY (CDTAG, CDFILIAL)
)
/

ALTER TABLE UNIDADETAG ADD CONSTRAINT FKVND00860UNIDADETAG FOREIGN KEY(CDTAG) REFERENCES TAG(CDTAG) 
/

CREATE INDEX VND00860_FK ON UNIDADETAG (CDTAG ASC)
/

ALTER TABLE UNIDADETAG ADD CONSTRAINT FKVND00861CDUNIDADETAG FOREIGN KEY(CDFILIAL) REFERENCES FILIAL(CDFILIAL) 
/

CREATE INDEX VND00861_FK ON UNIDADETAG (CDFILIAL ASC)
/

CREATE TABLE PRODUTOTAG(
    CDTAG             VARCHAR2(4)     NOT NULL,
    CDFILIAL          VARCHAR2(4)     NOT NULL,
    CDPRODUTO         VARCHAR2(10)    NOT NULL,    
    NRORG             NUMBER 	      DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') 		NOT NULL,
    IDATIVO           VARCHAR2(1)     DEFAULT 'S'					NOT NULL,
    DTINCLUSAO        DATE            DEFAULT SYSDATE,
    DTULTATU          DATE            DEFAULT SYSDATE,
    NRORGINCLUSAO     NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERINCLUSAO    VARCHAR2(12)    DEFAULT '1' 					NULL,
    NRORGULTATU       NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERULTATU      VARCHAR2(12)    DEFAULT '1',
	   CONSTRAINT CKC_IDATIVO_PRODUTOTAG CHECK (IDATIVO IN ('S','N')),
      CONSTRAINT PK_PRODUTOTAG PRIMARY KEY (CDTAG, CDFILIAL,CDPRODUTO)
)
/

ALTER TABLE PRODUTOTAG ADD CONSTRAINT FKVND00862PRODUTOTAG FOREIGN KEY(CDTAG) REFERENCES TAG(CDTAG) 
/

CREATE INDEX VND00862_FK ON PRODUTOTAG (CDTAG ASC)
/

ALTER TABLE PRODUTOTAG ADD CONSTRAINT FKVND00863PRODUTOTAGFILIAL FOREIGN KEY(CDFILIAL, CDPRODUTO) REFERENCES PRODFILI(CDFILIAL, CDPRODUTO) 
/

CREATE INDEX VND00863_FK ON PRODUTOTAG (CDFILIAL ASC, CDPRODUTO ASC)
/